# GeoModel Kernel Class Reference


This section describes in more detail the classes in the geometry kernel. In most cases we provide the class interface. In cases where part of the interface is used only internally by the geometry kernel itself and not by other users. In such cases we present a simplified picture of the interfaces.

Detailed descriptions of the geometry kernel classes follow.



{% include 'components/kernel/reference/ReferenceCounting.md' %}

{% include 'components/kernel/reference/Materials_Elements.md' %}

{% include 'components/kernel/reference/Shapes.md' %} 

{% include 'components/kernel/reference/LogicalVolumes.md' %}

{% include 'components/kernel/reference/PhysicalVolumes.md' %}

{% include 'components/kernel/reference/Transformations.md' %}

{% include 'components/kernel/reference/NameTags.md' %}

{% include 'components/kernel/reference/Parametrization.md' %}

{% include 'components/kernel/reference/Actions.md' %}

{% include 'components/kernel/reference/SubsystemDescription.md' %}

{% include 'components/kernel/reference/Appendix_Query.md' %}




